#include <iostream>
#include <bits/stdc++.h>

using namespace std;

/*7
1 7 2 7 2 2 3
4
1 4
2 7
4 6
3 7*/
int main()
{
    int q,n;
cin>>n;
vector<int> fosorozat,eredmeny;
for(int i=0;i<n;i++)
{
    int a;
    cin>>a;
    fosorozat.push_back(a);
}
cin>>q;
for(int i=0;i<q;i++)
{
int a,b;
cin>>a>>b;
if(b-a<=2)
{
    eredmeny.push_back(1);
}
else
{
    int talalte=0;
    while(a<b)
    {        int index=a-1;

        if(fosorozat[index]<=fosorozat[index+1])
        {
            a++;
        }
        else
        {

            talalte++;
            if(talalte==1)
            {
                if(index!=fosorozat.size()-2)
                {
                    if(fosorozat[index+2]<fosorozat[index]&&fosorozat[index+2]<fosorozat[index+1])
                    {
                        talalte=2;
                        break;
                    }
                    else
                    {;
                        a+=2;
                    }

                }
                else
                {
                    break;
                }
            }
            else
            {
                break;
            }
        }
    }
    if(talalte<2)
    {
        eredmeny.push_back(1);
    }
    else
    {
        eredmeny.push_back(0);
    }
}
}
for(int i=0;i<eredmeny.size();i++)
{
    if(eredmeny[i]==1)
    {
        cout<<"DA"<<endl;
    }
    else
    {
        cout<<"NE"<<endl;
    }
}
}